/* 
Gold Method alternative to Photograv for laser etching
Technique by: Rodney Gold
Coding by Doug Griffith
Much thanks to Frank Corker
see www.dogcollarlabor.com/smc for updates
*/
var versionNum = '1.03';
if (parseFloat(app.version) < 9) { 
alert('This script requires Photoshop CS2 or CS3');
win.close();
}
if (runningOnMac()) { fileLineFeed = "macintosh"; } else { fileLineFeed = "windows"; }
var fileName = '';
//var GM_settings=$.fileName.replace(/GoldMethod\.jsx$/,"");
var GM_settings = app.path + '/';
fileName = new File(GM_settings + "GoldMethod.txt");
//read settings
var settings = new Array;
var result = fileName.open("r", "TEXT", "");
if (result) {
	var index = 0;
	var line;
	while (!fileName.eof) {
		line = fileName.readln();
		if (line.search(/\S/) != -1)
			settings[index++] = line;
	}
}
#target photoshop
app.displayDialogs = DialogModes.NO; // suppress all dialogs
var oldPref = app.preferences.rulerUnits;	 //keep old prefs
app.preferences.rulerUnits = Units.PIXELS;
app.bringToFront(); // bring top
$.localize = true;  // Enable ZString localiation
var sCancelButton = localize("$$$/AdobePlugin/Shared/Cancel=Cancel");
var ui = // dialog resource object
"dialog { \
alignChildren: 'fill', \
aFiles: Panel { orientation: 'column', alignChildren:'left', text: 'File', g: Group { orientation: 'column', alignChildren:'left', }, }, \
pFiles: Panel { orientation: 'column', alignChildren:'left', text: 'Options', g: Group { orientation: 'row', alignChildren:'left', }, }, \
fFiles: Panel { orientation: 'column', alignChildren:'left', text: 'Adjust Grayscale', g: Group { orientation: 'row', alignChildren:'left', }, }, \
nFiles: Panel { orientation: 'column', alignChildren:'left', text: 'Adjust Sharpness', g: Group { orientation: 'row', alignChildren:'left', }, }, \
zFiles: Panel { orientation: 'column', alignChildren:'left', text: 'Resolution', g: Group { orientation: 'row', alignChildren:'left', }, }, \
cFiles: Group { orientation: 'row', alignChildren:'center', }, \
gButtons: Group { orientation: 'row', alignment: 'center' } } \
}";
if (app.documents.length == 0) {
	alert('Select the image file you wish to convert');
	if (runningOnMac())
		var dataFile = File.openDialog("Select data file");
	else // Windows
	var dataFile = File.openDialog("Select data file", "All files:*"); //Text files:*.txt;*.TXT,All files:*
} else {
	docRef = activeDocument;
}
var savedState;
var docRef;
var win = new Window (ui); //new window
win.text = 'Gold Method';//window title
win.center();
win.aFiles.text = 'File';
if (app.documents.length == 0) {
	win.aFiles.g.add('statictext', undefined,dataFile.fsName);
} else {
	win.aFiles.g.add('statictext', undefined,activeDocument.name);
}
win.pFiles.text = 'Options';
win.pFiles.g.add('checkbox', undefined,'Invert', {name:'invert'});
if (settings[2] == 'true') { win.pFiles.g.invert.value = true; }
win.pFiles.g.add('checkbox', undefined,'Flip Horizontal', {name:'flip'});
if (settings[3] == 'true') { win.pFiles.g.flip.value = true; }
win.zFiles.text = 'Resolution';
win.cbFiles = new Array();  // button array
win.cbFiles[0] = win.zFiles.g.add('button', undefined,'150 DPI', {name:'r150'});
win.cbFiles[1] = win.zFiles.g.add('button', undefined,'300 DPI', {name:'r300'});
win.cbFiles[2] = win.zFiles.g.add('button', undefined,'400 DPI', {name:'r400'});
win.cbFiles[3] = win.zFiles.g.add('button', undefined,'600 DPI', {name:'r600'});
win.gButtons.add('button', undefined,'Cancel', {name:'cancelB'});
win.cFiles.add('statictext', undefined,'v'+versionNum+' updates:www.dogcollarlabor.com/smc');
win.zFiles.g.r150.onClick = function () { proceedFunc('150'); };
win.zFiles.g.r300.onClick = function () { proceedFunc('300'); };
win.zFiles.g.r400.onClick = function () { proceedFunc('400'); };
win.zFiles.g.r600.onClick = function () { proceedFunc('600'); };
win.gButtons.cancelB.onClick = function () { win.hide(); };
win.fFiles.text = 'Adjust Grayscale  <DARKEN - LIGHTEN>';
win.fFiles.g.add("scrollbar",{x:200, y:200, width:200, height:20},	settings[0],-50,50,{name:'depth', stepdelta:1});  //slider
win.fFiles.g.add("edittext", {x:100, y:100, width:40, height:20}, settings[0], {name:'depthfield'});
win.fFiles.g.depth.onChanging = function () {
	win.fFiles.g.depthfield.text = Math.round(win.fFiles.g.depth.value);
}
win.nFiles.text = 'Adjust Sharpness  <LESS - MORE>';
win.nFiles.g.add("scrollbar",{x:200, y:200, width:200, height:20},settings[1],-50,50,{name:'sharp', stepdelta:1});  //slider
win.nFiles.g.add("edittext", {x:100, y:100, width:40, height:20}, settings[1], {name:'sharpfield'});
win.nFiles.g.sharp.onChanging = function () {
	win.nFiles.g.sharpfield.text = Math.round(win.nFiles.g.sharp.value);
}
var ret = win.show(); //create window
// User interface end
function proceedFunc(dpi) {
	var fileName = new File(GM_settings + "GoldMethod.txt");
	fileName.lineFeed = fileLineFeed;
	fileName.open("w", "TEXT", "????");
	fileName.write(win.fFiles.g.depthfield.text+"\r"); //grayscale
	fileName.write(win.nFiles.g.sharp.value+"\r"); //sharpness
	fileName.write(win.pFiles.g.invert.value+"\r"); //invert
	fileName.write(win.pFiles.g.flip.value); //flip
	fileName.close();
	var gAdjust = (parseFloat(win.fFiles.g.depthfield.text) + 50);
	var bAdjust = (parseFloat(win.fFiles.g.depthfield.text) * 2);
	var sAdjust = (((win.nFiles.g.sharp.value * 2) * .01) + 1.1);
	if (app.documents.length == 0) {
		var fileName = dataFile.fsName;
		docRef = open( File(fileName) );
	} else {
		docRef = activeDocument;
	}
	savedState = docRef.activeHistoryState; // save state
	docRef.changeMode(ChangeMode.LAB);
	docRef.channels[1].remove(); //delete a
	docRef.channels[1].remove(); //delete b
	docRef.changeMode(ChangeMode.GRAYSCALE); //grayscale
	//alert('TESTING BEFORE\n\nresolution='+app.activeDocument.resolution+'\nwidth='+docRef.width+'\nheight='+docRef.height);
	docRef.resizeImage(docRef.width,docRef.height,dpi,ResampleMethod.BICUBIC); //change resolution
	//alert('TESTING AFTER\n\nresolution='+dpi+'\nwidth='+docRef.width+'\nheight='+docRef.height);
	docRef.activeLayer.shadowHighlight(40,gAdjust,30,0,50,30,bAdjust,0,.01,10);
	docRef.activeLayer.autoLevels(); //levels
	docRef.activeLayer.applyUnSharpMask(500,3.5,0); //unsharp mask 1
	docRef.activeLayer.applyUnSharpMask(150,sAdjust,0); //unsharp mask 2
	if (win.pFiles.g.invert.value == true) { 
		docRef.activeLayer.invert(); //invert
	}
	if (win.pFiles.g.flip.value == true) { 
		docRef.flipCanvas(Direction.HORIZONTAL); //flip
	}
	//convert to bitmap
	var bitsaveoptions = new BitmapConversionOptions();
	bitsaveoptions.method = BitmapConversionType.DIFFUSIONDITHER;
	bitsaveoptions.resolution = dpi;
	docRef.changeMode(ChangeMode.BITMAP,bitsaveoptions);
	refresh();
	var proceed= confirm('Keep Changes'); 
	if (proceed) { 
		win.hide();
	} else {
		docRef.activeHistoryState = savedState;
	}
	app.preferences.rulerUnits = oldPref;
	docRef = null; //clean house
	refresh();
}
function runningOnMac() {
	return (File.fs.search(/mac/i) == 0);
}
